Package ec.parsimony

# Class BucketTournamentSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.parsimony.BucketTournamentSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class BucketTournamentSelection extends SelectionMethod implements SteadyStateBSourceForm
Does a tournament selection, limited to the subpopulation it's working in at the time.

Bucket Lexicographic Tournament selection works like as follows. There is a number of buckets (num-buckets) specified beforehand, and each is assigned a rank from 1 to num-buckets. The population, of size pop-size, is sorted by fitness. The bottom pop-size/num-buckets individuals are placed in the worst ranked bucket, plus any individuals remaining in the population with the same fitness as the best individual in the bucket. Then the second worst pop-size/num-buckets individuals are placed in the second worst ranked bucket, plus any individuals in the population equal in fitness to the best individual in that bucket. This continues until there are no individuals in the population. Note that the topmost bucket with individuals can hold fewer than pop-size/num-buckets individuals, if pop-size is not a multiple of num-buckets. Depending on the number of equal-fitness individuals in the population, there can be some top buckets that are never filled. The fitness of each individual in a bucket is set to the rank of the bucket holding it. Direct bucketing has the effect of trading off fitness differences for size. Thus the larger the bucket, the stronger the emphasis on size as a secondary objective. After ranking the individuals, size individuals are chosen at random from the population. Of those individuals, the one with the highest rank is selected. If the two individuals are in the same rank, meaning that they have similar fitness, the one with the smallest size is selected.

Bucket Lexicographic Tournament selection is so simple that it doesn't need to maintain a cache of any form, so many of the SelectionMethod methods just don't do anything at all.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`size` int >= 1 (default 7) | (the tournament size)
base.`pick-worst` bool = `true` or `false` (default) | (should we pick the worst individual in the tournament instead of the best?)
base.`num-buckets` int >= 1 (default 10) | (the number of buckets)

Default Base
select.bucket-tournament

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `N_BUCKETS_DEFAULT`
  Default number of buckets
  `static final String`
  `P_BUCKETS`
  The number of buckets
  `static final String`
  `P_PICKWORST`
  If the worst individual should be picked in the tournament
  `static final String`
  `P_SIZE`
  Tournament size parameter
  `static final String`
  `P_TOURNAMENT`
  Default base
  `boolean`
  `pickWorst`
  Do we pick the worst instead of the best?
  `int`
  `size`
  Size of the tournament

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BucketTournamentSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)`
  Called whenever an individual has been replaced by another in the population.
  `void`
  `prepareToProduce(EvolutionState state, int subpopulation, int thread)`
  Prepare to produce: create the buckets!!!!
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `void`
  `sourcesAreProperForm(SteadyStateEvolutionState state)`
  Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.

  ### Methods inherited from class ec.SelectionMethod

  `finishProducing, produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_TOURNAMENT

    public static final String P_TOURNAMENT
    Default base
    See Also:
      - Constant Field Values

  - ### P_PICKWORST

    public static final String P_PICKWORST
    If the worst individual should be picked in the tournament
    See Also:
      - Constant Field Values

  - ### P_SIZE

    public static final String P_SIZE
    Tournament size parameter
    See Also:
      - Constant Field Values

  - ### P_BUCKETS

    public static final String P_BUCKETS
    The number of buckets
    See Also:
      - Constant Field Values

  - ### N_BUCKETS_DEFAULT

    public static final int N_BUCKETS_DEFAULT
    Default number of buckets
    See Also:
      - Constant Field Values

  - ### size

    public int size
    Size of the tournament

  - ### pickWorst

    public boolean pickWorst
    Do we pick the worst instead of the best?

- ## Constructor Details

  - ### BucketTournamentSelection

    public BucketTournamentSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState state, int subpopulation, int thread)
    Prepare to produce: create the buckets!!!!
    Overrides:
      `prepareToProduce` in class `SelectionMethod`

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`

  - ### individualReplaced

    public void individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)
    Description copied from interface: `SteadyStateBSourceForm`
    Called whenever an individual has been replaced by another in the population.
    Specified by:
      `individualReplaced` in interface `SteadyStateBSourceForm`

  - ### sourcesAreProperForm

    public void sourcesAreProperForm(SteadyStateEvolutionState state)
    Description copied from interface: `SteadyStateBSourceForm`
    Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.
    Specified by:
      `sourcesAreProperForm` in interface `SteadyStateBSourceForm`